package cn.winhc.elasticsearch.plugin.analyzer;

import cn.winhc.elasticsearch.plugin.handle.Text2Tokenizer;
import org.apache.lucene.analysis.Analyzer;
import org.elasticsearch.common.settings.Settings;
import org.elasticsearch.env.Environment;
import org.elasticsearch.index.IndexSettings;
import org.elasticsearch.index.analysis.AbstractIndexAnalyzerProvider;

/**
 * @author: XuJiakai
 * 2021/11/8 10:00
 */
public class WinhcAnalyzerProvider extends AbstractIndexAnalyzerProvider<Analyzer> {
    /**
     * Constructs a new analyzer component, with the index name and its settings and the analyzer name.
     *
     * @param indexSettings the settings and the name of the index
     * @param name          The analyzer name
     * @param settings
     */
    public WinhcAnalyzerProvider(IndexSettings indexSettings, String name, Settings settings) {
        super(indexSettings, name, settings);
    }

    private Text2Tokenizer text2Tokenizer;


    public static WinhcAnalyzerProvider getInstance(IndexSettings indexSettings, Environment environment, String name, Settings settings, Text2Tokenizer text2Tokenizer) {
        WinhcAnalyzerProvider winhcAnalyzerProvider = new WinhcAnalyzerProvider(indexSettings, name, settings);
        winhcAnalyzerProvider.text2Tokenizer = text2Tokenizer;
        return winhcAnalyzerProvider;

    }


    @Override
    public Analyzer get() {
        return new WinhcAnalyzer(text2Tokenizer);
    }
}
