package cn.winhc.elasticsearch.plugin.entity;

/**
 * @author: XuJiakai
 * 2021/11/8 09:03
 */

public class Term {
    //词元的起始位移
    private int offset;
    //词元的相对起始位置
    private int end;
    //词元文本
    private String text;
    //词元类型
    private String lexemeType;

    public static Term of(String text, int offset, int end, String lexemeType) {
        Term term = new Term();
        term.setOffset(offset);
        term.setEnd(end);
        term.setText(text);
        term.setLexemeType(lexemeType);
        return term;
    }


    public int getOffset() {
        return offset;
    }

    public void setOffset(int offset) {
        this.offset = offset;
    }

    public int getEnd() {
        return end;
    }

    public void setEnd(int end) {
        this.end = end;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }

    public String getLexemeType() {
        return lexemeType;
    }

    public void setLexemeType(String lexemeType) {
        this.lexemeType = lexemeType;
    }

    @Override
    public String toString() {
        return "{" +
                "\"offset\":" + offset +
                ",\"end\":" + end +
                ", \"text\":\"" + text + '\"' +
                ", \"lexemeType\":\"" + lexemeType + '\"' +
                '}';
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Term term = (Term) o;

        if (offset != term.offset) return false;
        if (end != term.end) return false;
        return text != null ? text.equals(term.text) : term.text == null;
    }

    @Override
    public int hashCode() {
        int result = offset;
        result = 31 * result + end;
        result = 31 * result + (text != null ? text.hashCode() : 0);
        return result;
    }
}
