package cn.winhc.elasticsearch.plugin.test;

import cn.winhc.elasticsearch.plugin.entity.Term;
import cn.winhc.elasticsearch.plugin.util.DomainPostfixUtils;

import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author: XuJiakai
 * 2021/11/9 09:26
 */
public class XjkTest {
    private static final Pattern urlPattern = Pattern.compile("((http://)|(https://))?(www\\.)?([0-9a-zA-Z\\-_\\u4e00-\\u9fa5]+(\\.[a-zA-Z\\u4e00-\\u9fa5]+){1,2}).*");

    private static Object test(String line) {
        Matcher matcher = urlPattern.matcher(line);
        if (matcher.matches()) {
            String url = matcher.group(5);
            String trimUrl = DomainPostfixUtils.trimDomainPostfix(url);
            int urlIndex = line.indexOf(url);
            int trimUrlIndex = line.indexOf(trimUrl);
            return Arrays.asList(
                    Term.of(url, urlIndex, urlIndex + url.length(), "url")
                    , Term.of(trimUrl, trimUrlIndex, trimUrlIndex + trimUrl.length(), "trim_url")
            );
        }
        return null;
    }

    public static void main(String[] args) {
        Object test = test("https://www.baidu.com");
        System.out.println(test);

    }
}
