package cn.winhc.elasticsearch.plugin.tokenizer;

import cn.winhc.elasticsearch.plugin.handle.Text2Tokenizer;
import org.apache.lucene.analysis.Tokenizer;
import org.elasticsearch.common.settings.Settings;
import org.elasticsearch.env.Environment;
import org.elasticsearch.index.IndexSettings;
import org.elasticsearch.index.analysis.AbstractTokenizerFactory;
import org.elasticsearch.index.analysis.TokenizerFactory;

/**
 * @author: XuJiakai
 * 2021/11/8 10:03
 */
public class WinhcTokenizerFactory extends AbstractTokenizerFactory {
    private Text2Tokenizer text2Tokenizer;

    public WinhcTokenizerFactory(IndexSettings indexSettings, Environment environment, String ignored, Settings settings, Text2Tokenizer text2Tokenizer) {
        super(indexSettings, ignored, settings);
        this.text2Tokenizer = text2Tokenizer;
    }


    public static TokenizerFactory getTokenizerFactory(IndexSettings indexSettings, Environment environment, String name, Settings settings, Text2Tokenizer text2Tokenizer) {
        return new WinhcTokenizerFactory(indexSettings, environment, name, settings, text2Tokenizer);
    }

    @Override
    public Tokenizer create() {
        return new WinhcTokenizer(text2Tokenizer);
    }
}
