package cn.winhc.elasticsearch.plugin.util;

import java.util.HashSet;
import java.util.Set;

/**
 * @author: XuJiakai
 * 2021/11/8 09:37
 */
public class DomainPostfixUtils {

    private static Set<String> internationalDomain = new HashSet<String>() {
        {
            add(".com");
            add(".edu.cn");
            add(".jp");
            add(".sb");
            add(".mx");
            add(".sj");
            add(".ph");
            add(".er");
            add(".fk");
            add(".id");
            add(".nm.cn");
            add(".mu");
            add(".sz");
            add(".mn");
            add(".gm");
            add(".cd");
            add(".fm");
            add(".eu");
            add(".qa");
            add(".hn");
            add(".mw");
            add(".bd");
            add(".ly");
            add(".us");
            add(".xxx");
            add(".so");
            add(".do");
            add(".la");
            add(".by");
            add(".vu");
            add(".ki");
            add(".ne");
            add(".es");
            add(".mo");
            add(".bm");
            add(".mm");
            add(".fi");
            add(".td");
            add(".hu");
            add(".zw");
            add(".kh");
            add(".sn");
            add(".in");
            add(".cc");
            add(".int");
            add(".mr");
            add(".ah.cn");
            add(".um");
            add(".pt");
            add(".be");
            add(".ru");
            add(".gl");
            add(".ms");
            add(".cy");
            add(".ch");
            add(".gov");
            add(".cv");
            add(".tr");
            add(".pro");
            add(".com.cn");
            add(".fj.cn");
            add(".af");
            add(".ro");
            add(".gt");
            add(".az");
            add(".lu");
            add(".gs.cn");
            add(".mp");
            add(".jx.cn");
            add(".ua");
            add(".bo");
            add(".tm");
            add(".nr");
            add(".pk");
            add(".as");
            add(".ps");
            add(".mt");
            add(".ie");
            add(".bj");
            add(".gg");
            add(".bt");
            add(".vg");
            add(".ag");
            add(".cn");
            add(".dj");
            add(".ls");
            add(".gy");
            add(".kw");
            add(".pf");
            add(".bh");
            add(".bf");
            add(".al");
            add(".dk");
            add(".uz");
            add(".lc");
            add(".nz");
            add(".ws");
            add(".de");
            add(".edu");
            add(".fr");
            add(".tz");
            add(".nc");
            add(".org");
            add(".bg");
            add(".pg");
            add(".name");
            add(".ck");
            add(".mh");
            add(".tl");
            add(".ac.cn");
            add(".yr");
            add(".ln.cn");
            add(".tf");
            add(".nl");
            add(".ai");
            add(".gp");
            add(".fo");
            add(".gd");
            add(".ao");
            add(".yt");
            add(".np");
            add(".ba");
            add(".ci");
            add(".an");
            add(".ar");
            add(".hi.cn");
            add(".jo");
            add(".sv");
            add(".aw");
            add(".gs");
            add(".aq");
            add(".rw");
            add(".mk");
            add(".nf");
            add(".vi");
            add(".tp");
            add(".va");
            add(".sk");
            add(".tn");
            add(".bs");
            add(".tk");
            add(".wf");
            add(".kp");
            add(".st");
            add(".vn");
            add(".mo.cn");
            add(".coop");
            add(".hk");
            add(".na");
            add(".to");
            add(".nu");
            add(".li");
            add(".gr");
            add(".jm");
            add(".hb.cn");
            add(".gw");
            add(".lr");
            add(".eg");
            add(".js.cn");
            add(".ec");
            add(".pn");
            add(".sm");
            add(".je");
            add(".jl.cn");
            add(".biz");
            add(".kr");
            add(".lt");
            add(".im");
            add(".si");
            add(".pl");
            add(".ml");
            add(".au");
            add(".md");
            add(".at");
            add(".za");
            add(".mc");
            add(".ac");
            add(".my");
            add(".ht");
            add(".bn");
            add(".is");
            add(".ke");
            add(".se");
            add(".ve");
            add(".ma");
            add(".ug");
            add(".hl.cn");
            add(".cu");
            add(".ge");
            add(".ee");
            add(".aero");
            add(".bz");
            add(".lb");
            add(".py");
            add(".gx.cn");
            add(".museum");
            add(".ha.cn");
            add(".net.cn");
            add(".org.cn");
            add(".bw");
            add(".gq");
            add(".tv");
            add(".pr");
            add(".bj.cn");
            add(".gov.cn");
            add(".mq");
            add(".cr");
            add(".info");
            add(".tg");
            add(".ye");
            add(".ca");
            add(".gz.cn");
            add(".uy");
            add(".bb");
            add(".ae");
            add(".mv");
            add(".re");
            add(".pw");
            add(".ga");
            add(".yu");
            add(".ad");
            add(".nx.cn");
            add(".kn");
            add(".zm");
            add(".ir");
            add(".hm");
            add(".gu");
            add(".pa");
            add(".pe");
            add(".hr");
            add(".no");
            add(".cx");
            add(".net");
            add(".tt");
            add(".cl");
            add(".he.cn");
            add(".lv");
            add(".cm");
            add(".pm");
            add(".br");
            add(".gf");
            add(".gn");
            add(".gh");
            add(".sc");
            add(".sy");
            add(".cz");
            add(".mz");
            add(".iq");
            add(".cg");
            add(".it");
            add(".cf");
            add(".bv");
            add(".kz");
            add(".vc");
            add(".sl");
            add(".mil");
            add(".mg");
            add(".io");
            add(".sh");
            add(".gi");
            add(".sd");
            add(".dz");
            add(".tc");
            add(".ky");
            add(".km");
            add(".bi");
            add(".idv");
            add(".sr");
            add(".om");
            add(".co");
            add(".eh");
            add(".uk");
            add(".kg");
            add(".ng");
            add(".gd.cn");
            add(".fj");
            add(".il");
            add(".sa");
            add(".lk");
            add(".tw");
            add(".dm");
            add(".sg");
            add(".am");
            add(".hn.cn");
            add(".th");
            add(".tj");
            add(".hk.cn");
            add(".et");
            add(".ni");
            add(".cq.cn");
        }
    };


    private static Set<String> allDomain = new HashSet<>(internationalDomain);


    public static String trimDomainPostfix(String domain) {
        if (domain == null) {
            return null;
        }
        return allDomain.stream().filter(domain::endsWith).map(f -> domain.substring(0, domain.length() - f.length())).findFirst().orElse(domain);
    }
}
