package cn.winhc.elasticsearch.plugin.util;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author: XuJiakai
 * 2021/11/9 09:48
 */
public class DomainUtils {

    private static final Pattern email = Pattern.compile("[a-z_A-Z0-9\\-]+@[a-zA-Z\\-]+[\\.(a-zA-Z\\-)]+");

    private static final Pattern domainPattern = Pattern.compile("((http://)|(https://))?(www\\.)?([0-9a-zA-Z\\-_]+(\\.[a-zA-Z]+){1,2})(/.+)?");


    public static List<String> getDomain(String text) {
        Matcher matcher = domainPattern.matcher(text);
        ArrayList<String> emails = new ArrayList<>();
        while (matcher.find()) {
            String group = matcher.group();
            emails.add(group);
        }
        return emails;
    }


    public static List<String> getEmails(String text) {
        Matcher matcher = email.matcher(text);
        ArrayList<String> emails = new ArrayList<>();
        while (matcher.find()) {
            String group = matcher.group();
            emails.add(group);
        }
        return emails;
    }

    public static void main(String[] args) {
        List<String> domain = getDomain("https://www.baidu.com.pro你好http://baidu.com.cn完全vbindex.html");

        System.out.println(domain);

    }
}
